
/***********************************************
*               ***  EFFETTI  ***              *
*    Libreria per la generazione di effetti    *
*              con il decoder 4511             *
*                                              *
*   Firmware version: 2.0                      *
*   Autore: Battistella Mirco                  *
*   Data: 09/11/2013                           *
*   Piattaforma software: MPLAB X v1.80        *
*   Compilatore: XC8 v1.20                     *
*                                              *
***********************************************/


#include <xc.h>
#include "Decoder_4511.h" //File per il comando del decoder 4511


#ifndef EFFETTI_H //Se la libreria non  gi stata inclusa
#define	EFFETTI_H //Imposta un #define per evitare doppie inclusioni

void effetto_scivolata(unsigned char HH, unsigned char MM)
//Questo effetto incrementa un numero da 0 a 9 e lo visualizza consecutivamente sui 4 display, partendo da sinistra a destra, fermandosi
//sul display corretto e visualizzando il relativo numero (es. unit ore - display 2, decine minuti - display 3, ecc.) . Per ogni display, il
//numero viene incrementato almeno 5 volte, creando un effetto di rotazione e, mano a mano che il conteggio avanza, viene traslato e
//incrementato fino a raggiungere il display di destinazione.
{
    unsigned char n; //Variabile contatore per spostare la visualizzazione delle cifre da un display all'altro
    unsigned char i; //Variabile contatore per che indica il numero di incrementi della varibile val per ogni display
    unsigned char val=0; //Variabile con il numero provvisorio da visualizzare su di un display
    unsigned int conteggio; //Variabile con il numero di visualizzazioni di un numero in un dato display (equivalente al tempo di visualizzazione)
    const unsigned char tScorr=10; //Costante di visualizzazione di un numero in un dato display (vedi conteggio)

    num[0]=10; //Assegno a tutti i display la cifra 10 (ovvero nessun numero visualizzato)
    num[1]=10;
    num[2]=10;
    num[3]=10;

    //1 STADIO
    for(n=0;n<4;n++) //Ciclo for che si ripete per tutti e 4 i display - traslazione del numero da visualizzare
    {
        for(i=0;i<5;i++) //Ciclo for che si ripete per 5 volte - incremento del numero da visualizzare
        {
            num[n]=val; //Assegna al display corrente (n viene definito dal primo ciclo for) il valore attuale del numero da visualizzare

            if(val<9) //Se il numero  inferiore a 9
            {
                val++; //Incrementa il numero
            }
            else //Altrimenti
            {
                val=0; //Azzera il numero
            }

            for(conteggio=0;conteggio<tScorr;conteggio++) //Ciclo for che si ripete per 10 volte (tempo di visualizzazione del numero prima dell'incremento)
            {
                visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
            }

            if(n!=3 && i==4) //Se il numero si trova in un display diverso da quello di destinazione e ho finito i cicli per questo display
            {
                num[n]=10; //Assegna a quel display il numero 10 (ovvero, non fargli visualizzare nessun numero)
            }
        }
    }

    while(val!=(MM%10)) //Quando hai raggiunto il display di destinazione, incrementa il numero fino a quando non corrisponde al valore
    {                   //corretto da visualizzare (in questo caso le unit dei minuti)
        if(val<9) //Se il numero  inferiore a 9
        {
            val++; //Incrementa il numero
        }
        else //Altrimenti
        {
            val=0; //Azzera il numero
        }

        num[3]=val; //Assegna al quarto display il numero provvisorio da visualizzare

        for(conteggio=0;conteggio<tScorr;conteggio++) //Ciclo for che si ripete per 10 volte (tempo di visualizzazione del numero prima dell'incremento)
        {
            visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
        }
    }

    num[3]=MM%10; //Forza il valore corretto sul display di destinazione (sicurezza)

    visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display

    //2 STADIO
    for(n=0;n<3;n++) //Ciclo for che si ripete per i primi tre display ( l'ultimo  gia assegnato) - traslazione del numero da visualizzare
    {
        for(i=0;i<5;i++) //Ciclo for che si ripete per 5 volte - incremento del numero da visualizzare
        {
            num[n]=val; //Assegna al display corrente (n viene definito dal primo ciclo for) il valore attuale del numero da visualizzare

            if(val<9) //Se il numero  inferiore a 9
            {
                val++; //Incrementa il numero
            }
            else //Altrimenti
            {
                val=0; //Azzera il numero
            }

            for(conteggio=0;conteggio<tScorr;conteggio++) //Ciclo for che si ripete per 10 volte (tempo di visualizzazione del numero prima dell'incremento)
            {
                visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
            }

            if(n!=2 && i==4) //Se il numero si trova in un display diverso da quello di destinazione e ho finito i cicli per questo display
            {
                num[n]=10; //Assegna a quel display il numero 10 (ovvero, non fargli visualizzare nessun numero)
            }
        }
    }

    while(val!=(MM/10)) //Quando hai raggiunto il display di destinazione, incrementa il numero fino a quando non corrisponde al valore
    {                   //corretto da visualizzare (in questo caso le decine dei minuti)
        if(val<9) //Se il numero  inferiore a 9
        {
            val++; //Incrementa il numero
        }
        else //Altrimenti
        {
            val=0; //Azzera il numero
        }
        
        num[2]=val; //Assegna al terzo display il numero provvisorio da visualizzare

        for(conteggio=0;conteggio<tScorr;conteggio++) //Ciclo for che si ripete per 10 volte (tempo di visualizzazione del numero prima dell'incremento)
        {
            visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
        }
    }

    num[2]=MM/10; //Forza il valore corretto sul display di destinazione (sicurezza)

    visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display

    //3 STADIO
    for(n=0;n<2;n++) //Ciclo for che si ripete per i primi due display ( gli ultimi due sono gi assegnati) - traslazione del numero da visualizzare
    {
        for(i=0;i<5;i++) //Ciclo for che si ripete per 5 volte - incremento del numero da visualizzare
        {
            num[n]=val; //Assegna al display corrente (n viene definito dal primo ciclo for) il valore attuale del numero da visualizzare

            if(val<9) //Se il numero  inferiore a 9
            {
                val++; //Incrementa il numero
            }
            else //Altrimenti
            {
                val=0; //Azzera il numero
            }
            for(conteggio=0;conteggio<tScorr;conteggio++) //Ciclo for che si ripete per 10 volte (tempo di visualizzazione del numero prima dell'incremento)
            {
                visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
            }
            if(n!=1 && i==4) //Se il numero si trova in un display diverso da quello di destinazione e ho finito i cicli per questo display
            {
                num[n]=10; //Assegna a quel display il numero 10 (ovvero, non fargli visualizzare nessun numero)
            }
        }
    }

    while(val!=(HH%10)) //Quando hai raggiunto il display di destinazione, incrementa il numero fino a quando non corrisponde al valore
    {                   //corretto da visualizzare (in questo caso le unit delle ore)
        if(val<9) //Se il numero  inferiore a 9
        {
            val++; //Incrementa il numero
        }
        else //Altrimenti
        {
            val=0; //Azzera il numero
        }

        num[1]=val; //Assegna al secondo display il numero provvisorio da visualizzare

        for(conteggio=0;conteggio<tScorr;conteggio++) //Ciclo for che si ripete per 10 volte (tempo di visualizzazione del numero prima dell'incremento)
        {
            visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
        }
    }

    num[1]=HH%10; //Forza il valore corretto sul display di destinazione (sicurezza)

    visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display

    //4 STADIO - Solo per il primo display ( gli altri sono gi assegnati) - nessuna traslazione
    for(i=0;i<5;i++) //Ciclo for che si ripete per 5 volte - incremento del numero da visualizzare
    {
        num[0]=val; //Assegna al display corrente (n viene definito dal primo ciclo for) il valore attuale del numero da visualizzare

        if(val<9) //Se il numero  inferiore a 9
        {
            val++; //Incrementa il numero
        }
        else //Altrimenti
        {
            val=0; //Azzera il numero
        }

        for(conteggio=0;conteggio<tScorr;conteggio++) //Ciclo for che si ripete per 10 volte (tempo di visualizzazione del numero prima dell'incremento)
        {
            visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
        }
    }

    while(val!=(HH/10)) //Quando hai raggiunto il display di destinazione, incrementa il numero fino a quando non corrisponde al valore
    {                   //corretto da visualizzare (in questo caso le decine delle ore)
        if(val<9) //Se il numero  inferiore a 9
        {
            val++; //Incrementa il numero
        }
        else //Altrimenti
        {
            val=0; //Azzera il numero
        }

        num[0]=val; //Assegna al primo display il numero provvisorio da visualizzare

        for(conteggio=0;conteggio<tScorr;conteggio++) //Ciclo for che si ripete per 10 volte (tempo di visualizzazione del numero prima dell'incremento)
        {
            visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
        }
    }

    num[0]=HH/10; //Forza il valore corretto sul display di destinazione (sicurezza)

    visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
}

void rotazioneNumeri(unsigned char enNum1, unsigned char enNum2, unsigned char enNum3, unsigned char enNum4)
//Questo effetto, usato all'interno di funzioni pi complesse, incrementa i numeri dei singoli display da 0 a 9 fintanto che i singoli
//incrementi sono abilitati.
{
    unsigned int conteggio; //Variabile con il numero di visualizzazioni di un numero in un dato display (equivalente al tempo di visualizzazione)
    unsigned char tScorr=10; //Costante di visualizzazione di un numero in un dato display (vedi conteggio)

    if(enNum1==1) //Se l'incremento del numero visualizzato nel primo display  abilitato
    {
        if(num[0]<9) //Se il numero  inferiore a 9
        {
            num[0]++; //Incrementa il numero
        }
        else //Altrimenti
        {
            num[0]=0; //Azzera il numero
        }
    }

    if(enNum2==1) //Se l'incremento del numero visualizzato nel secondo display  abilitato
    {
        if(num[1]<9) //Se il numero  inferiore a 9
        {
            num[1]++; //Incrementa il numero
        }
        else //Altrimenti
        {
            num[1]=0; //Azzera il numero
        }
    }

    if(enNum3==1) //Se l'incremento del numero visualizzato nel terzo display  abilitato
    {
        if(num[2]<9) //Se il numero  inferiore a 9
        {
            num[2]++; //Incrementa il numero
        }
        else //Altrimenti
        {
            num[2]=0; //Azzera il numero
        }
    }

    if(enNum4==1) //Se l'incremento del numero visualizzato nel quarto display  abilitato
    {
        if(num[3]<9) //Se il numero  inferiore a 9
        {
            num[3]++; //Incrementa il numero
        }
        else //Altrimenti
        {
            num[3]=0; //Azzera il numero
        }
    }

    for(conteggio=0;conteggio<tScorr;conteggio++) //Ciclo for che si ripete per 10 volte (tempo di visualizzazione dei numeri)
    {
        visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
    }
}

void effetto_slotMachine(unsigned char HH, unsigned char MM)
//Questo effetto fa ruotare i numeri di tutti i display, incrementandoli da 0 a 9, e bloccandoli in sequanza dall'ultimo al primo display quando
//raggiungono il valore corretto da visualizzare nel relativo display.
{
    unsigned char i; //Variabile contatore
    unsigned char nRotazioni=10; //Numero dei cicli di rotazione

    for(i=0;i<nRotazioni;i++) //Ciclo for di rotazione dei numeri che si ripete per 10 volte
    {
        rotazioneNumeri(1,1,1,1); //Richiama la funzione di rotazione dei numeri di tutti i display
    }
    while(num[3]!=(MM%10)) //Esegui i cicli di rotazione fino a quando il numero da visuaizzare nel quarto display corrisponde alle unit dei minuti
    {
        rotazioneNumeri(1,1,1,1); //Richiama la funzione di rotazione dei numeri di tutti i display
    }

    for(i=0;i<nRotazioni;i++) //Ciclo for di rotazione dei numeri che si ripete per 10 volte
    {
        rotazioneNumeri(1,1,1,0); //Richiama la funzione di rotazione dei numeri dei primi tre display
    }
    while(num[2]!=(MM/10)) //Esegui i cicli di rotazione fino a quando il numero da visuaizzare nel terzo display corrisponde alle decine dei minuti
    {
        rotazioneNumeri(1,1,1,0); //Richiama la funzione di rotazione dei numeri dei primi tre display
    }

    for(i=0;i<nRotazioni;i++) //Ciclo for di rotazione dei numeri che si ripete per 10 volte
    {
        rotazioneNumeri(1,1,0,0); //Richiama la funzione di rotazione dei numeri dei primi due display
    }
    while(num[1]!=(HH%10)) //Esegui i cicli di rotazione fino a quando il numero da visuaizzare nel secondo display corrisponde alle unit delle ore
    {
        rotazioneNumeri(1,1,0,0); //Richiama la funzione di rotazione dei numeri dei primi due display
    }

    for(i=0;i<nRotazioni;i++) //Ciclo for di rotazione dei numeri che si ripete per 10 volte
    {
        rotazioneNumeri(1,0,0,0); //Richiama la funzione di rotazione dei numeri del primo display
    }
    while(num[0]!=(HH/10)) //Esegui i cicli di rotazione fino a quando il numero da visuaizzare nel primo display corrisponde alle decine delle ore
    {
        rotazioneNumeri(1,0,0,0); //Richiama la funzione di rotazione dei numeri del primo display
    }
}

void effetto_ghost(unsigned char HH, unsigned char MM)
//Questo effetto, molto simile a quello di scivolata, si differenzia da quest'ultimo in quanto visualizza la progressione del numero corrente a
//caso fra i display, mostrando alla fine i relativi numeri corretti.
{
    unsigned char n=0; //Variabile provvisoria con il numero corrente da visualizzare
    unsigned char i=0; //Numero di incrementi da visualizzare per ciascun display
    unsigned char j=0; //Variabile contatore che seleziona in modo casuale (all'interno della matrice posCasuale) un display nel quale visualizzare il numero corrente
    unsigned char pos=0; //Variabile con numero del display attivo
    unsigned int conteggio; //Variabile con il numero di visualizzazioni di un numero in un dato display (equivalente al tempo di visualizzazione)
    unsigned char tScorr=10; //Costante di visualizzazione di un numero in un dato display (vedi conteggio)
    const unsigned char posCasuale[]={1,3,4,2,3,1,4,2}; //Matrice per la selezione casuale di un display nel quale visualizzare il numero corrente

    num[0]=10; //Assegno a tutti i display la cifra 10 (ovvero nessun numero visualizzato)
    num[1]=10;
    num[2]=10;
    num[3]=10;

    for(j=0;j<8;j++) //Ciclo for che si ripete per 8 volte - selezione casuale per 8 volte di un display nel quale visualizzare il numero corrente
    {
        pos=posCasuale[j]-1; //Selezione del display all'interno della matrice

        for(i=0;i<5;i++) //Ciclo for che si ripete 5 volte - incremento e visualizzazione del numero corrente
        {
            num[pos]=n; //Assegnazione del numero corrente al display selezionato dalla matrice

            for(conteggio=0;conteggio<tScorr;conteggio++) //Ciclo for che si ripete per 10 volte (tempo di visualizzazione del numero prima dell'incremento)
            {
                visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
            }

            if(n<9) //Se il numero  inferiore a 9
            {
                n++; //Incrementa il numero
            }
            else //Altrimenti
            {
                n=0; //Azzera il numero
            }
        }
        num[pos]=10; //Assegna al display selezionato il numero 10 (nessun numero visualizzato)
    }

    for(j=0;j<4;j++) //Ciclo for che si ripete per 4 volte - selezione casuale per 4 volte di un display nel quale visualizzare il numero corrente
    {
        pos=posCasuale[j]-1; //Selezione del display all'interno della matrice

        for(i=0;i<5;i++) //Ciclo for che si ripete 5 volte - incremento e visualizzazione del numero corrente
        {
            num[pos]=n; //Assegnazione del numero corrente al display selezionato dalla matrice

            for(conteggio=0;conteggio<tScorr;conteggio++) //Ciclo for che si ripete per 10 volte (tempo di visualizzazione del numero prima dell'incremento)
            {
                visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
            }
            if(n<9) //Se il numero  inferiore a 9
            {
                n++; //Incrementa il numero
            }
            else //Altrimenti
            {
                n=0; //Azzera il numero
            }
        }

        switch (pos) //Selettore switch per assegnare al display corrente il valore corretto da visualizzare
        {
            case 0:
               num[0]=HH/10; break;
            case 1:
               num[1]=HH%10; break;
            case 2:
               num[2]=MM/10; break;
            default:
               num[3]=MM%10; break;
        }
    }
}

void effetto_scorrimento(unsigned char HH, unsigned char MM)
{
    unsigned char i=0; //Variabile contatore del numero di traslazioni dei numeri
    unsigned char valTemp1=10; //Variabile temporanea n. 1 necessaria ad imagazzinare i numeri fuori dal display
    unsigned char valTemp2=10; //Variabile temporanea n. 2 necessaria ad imagazzinare i numeri fuori dal display
    unsigned char valTemp3=10; //Variabile temporanea n. 3 necessaria ad imagazzinare i numeri fuori dal display
    unsigned int conteggio; //Variabile con il numero di visualizzazioni di un numero in un dato display (equivalente al tempo di visualizzazione)
    unsigned char tScorr=90; //Costante di visualizzazione di un numero in un dato display (vedi conteggio)

    num[0]=HH/10; //Assegno al primo valore della matrice (display n. 1) le decine delle ore
    num[1]=HH%10; //Assegno al secondo valore della matrice (display n. 2) le unit delle ore
    num[2]=MM/10; //Assegno al terzo valore della matrice (display n. 3) le decine dei minuti
    num[3]=MM%10; //Assegno al quarto valore della matrice (display n. 4) le unit dei minuti

    //1 ciclo di accelerazione
    for(i=0;i!=7;i++) //Ciclo che si ripete per 7 volte - il ciclo serve per far scorrere i numeri accelerando progressivamente lo scorrimento
    {
        valTemp3=valTemp2; //Assegna alla variabile temporanea 3 il valore della variabile temporanea 2
        valTemp2=valTemp1; //Assegna alla variabile temporanea 2 il valore della variabile temporanea 1
        valTemp1=num[3]; //Assegna alla variabile temporanea 1 il quarto valore della matrice
        num[3]=num[2]; //Assegna al quarto valore della matrice il terzo valore della matrice
        num[2]=num[1]; //Assegna al terzo valore della matrice il secondo valore della matrice
        num[1]=num[0]; //Assegna al secondo valore della matrice il primo valore della matrice
        num[0]=valTemp3; //Assegna al primo valore della matrice il valore della variabile temporanea 3
        
        for(conteggio=0;conteggio!=tScorr;conteggio++) //Ciclo for che si ripete per n volte (tempo di visualizzazione del numero prima dell'incremento)
        {
            visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
        }

        tScorr-=10; //Accorcia il tempo fra uno scorrimento e l'altro dei numeri per creare un effetto di accelerazione
    }
    //2 ciclo a velocit costante
    for(i=0;i!=22;i++) //Ciclo che si ripete per 22 volte - il ciclo serve per far scorrere i numeri a velocit costante
    {
        valTemp3=valTemp2; //Assegna alla variabile temporanea 3 il valore della variabile temporanea 2
        valTemp2=valTemp1; //Assegna alla variabile temporanea 2 il valore della variabile temporanea 1
        valTemp1=num[3]; //Assegna alla variabile temporanea 1 il quarto valore della matrice
        num[3]=num[2]; //Assegna al quarto valore della matrice il terzo valore della matrice
        num[2]=num[1]; //Assegna al terzo valore della matrice il secondo valore della matrice
        num[1]=num[0]; //Assegna al secondo valore della matrice il primo valore della matrice
        num[0]=valTemp3; //Assegna al primo valore della matrice il valore della variabile temporanea 3
        
        for(conteggio=0;conteggio!=tScorr;conteggio++) //Ciclo for che si ripete per n volte (tempo di visualizzazione del numero prima dell'incremento)
        {
            visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
        }
    }
    //3 ciclo di decelerazione
    for(i=0;i!=7;i++) //Ciclo che si ripete per 7 volte - il ciclo serve per far scorrere i numeri decelerando progressivamente lo scorrimento
    {
        valTemp3=valTemp2; //Assegna alla variabile temporanea 3 il valore della variabile temporanea 2
        valTemp2=valTemp1; //Assegna alla variabile temporanea 2 il valore della variabile temporanea 1
        valTemp1=num[3]; //Assegna alla variabile temporanea 1 il quarto valore della matrice
        num[3]=num[2]; //Assegna al quarto valore della matrice il terzo valore della matrice
        num[2]=num[1]; //Assegna al terzo valore della matrice il secondo valore della matrice
        num[1]=num[0]; //Assegna al secondo valore della matrice il primo valore della matrice
        num[0]=valTemp3; //Assegna al primo valore della matrice il valore della variabile temporanea 3
        
        for(conteggio=0;conteggio!=tScorr;conteggio++) //Ciclo for che si ripete per n volte (tempo di visualizzazione del numero prima dell'incremento)
        {
            visualizzaSingleDigit(num[0], num[1], num[2], num[3]); //Ciclo di visualizzazione del display
        }

        tScorr+=10; //Aumenta il tempo fra uno scorrimento e l'altro dei numeri per creare un effetto di decelerazione e riportare tScorr al valore di partenza
    }
}

void effettoCasuale(unsigned char HH, unsigned char MM, unsigned char numFX)
//Questa funzione richiama un effetto in modo casuale. Riceve in ingresso, oltre che ai parametri ore e minuti, un numero che serve a selezionare,
//all'interno della matrice numCasuale, un numero collegato all'effetto da richiamare.
{
    unsigned char numCasuale[]={3,5,1,2,8,4,9,7,6,1,5,9,3,2,7,8,6,4,3,9,2,1,4,5,8,6,7,1,9,5}; //Matrice con i numeri casuali legati agli effetti da richiamare
    unsigned char posFX; //Variabile contenente il numero derivato dalla selezione

    posFX=numCasuale[numFX]; //Assegno alla variabile un numero casuale contenuto all'interno della matrice numCasuale

    switch(posFX) //Selettore switch per associare il numero ricavato ad un effetto specifico. Numeri si estendono fino a 9 per lasciare spazio
    {             //all'integrazione di altri effetti
        case 1:
            effetto_scivolata(HH,MM); break;
        case 2:
            effetto_scivolata(HH,MM); break;
        case 3:
            effetto_scorrimento(HH,MM); break;
        case 4:
            effetto_scorrimento(HH,MM); break;
        case 5:
            effetto_ghost(HH,MM); break;
        case 6:
            effetto_ghost(HH,MM); break;
        case 7:
            effetto_slotMachine(HH,MM); break;
        case 8:
            effetto_slotMachine(HH,MM); break;
        case 9:
            effetto_slotMachine(HH,MM); break;
        default:
            effetto_scivolata(HH,MM); break;
    }
}

#endif	/* EFFETTI_H */

