
/***********************************************
*        ***  SETTAGGI PRINCIPALI  ***         *
*        Funzione per il settaggio dei         *
*            parametri principali              *
*                                              *
*   Firmware version: 1.0                      *
*   Autore: Battistella Mirco                  *
*   Data: 09/11/2013                           *
*   Piattaforma software: MPLAB X v1.80        *
*   Compilatore: XC8 v1.20                     *
*                                              *
***********************************************/


void settaggiPrincipali()
//Funzione per il settaggio dei parametri principali utilizzati in questa applicazione
{
    TRISA = 0b00111110; //Imposto i pin RA1-RA5 come ingressi, gli altri come uscite
    TRISB = 0x00; //Imposto tutti i pin del portB come uscite
    LATA = 0x00; //Azzera lo stato delle uscite del portA
    LATB = 0x00; //Azzera lo stato delle uscite del portB
    ANSELA=0x00; //Disattiva i canali analogici sul portA
    ANSELB=0x00; //Disattiva i canali analogici sul portA
    WPUA=0x00; //Disattiva i canali analogici sul portB
    WPUB=0x00; //Disabilita le resistenze di pull-up interne (gi presenti nell'hardware)
    OPTION_REG=0b00000010; //Imposta registro OPITION_REG (con quarzo a 4MHz)
    //bit 7 WPUEN:  0 = Resistenze di pull-up abilitate e gestite dai singoli bit WPU
    //bit 6 INTEDG: 0 = Lancio interrupt sul fronte di discesa del segnale nel pin RB0/INT (qui non usato)
    //bit 5 TMR0CS: 0 = Sorgente di clock del Timer 0 interna (FOSC/4)
    //bit 4 TMR0SE: 0 = Incremento del Timer0 (con sorgente di clock esterna) sulla transizione del segnale
    //                  del pinRA4/T0CKI da basso a d alto (qui non usato)
    //bit 3 PSA:    0 = Il prescaler  assegnato al Timer0
    //bit 2-0 PS<2:0>: 010 = Valore del prescaler settato a 8
    TMR0=131; //Precaricamento TIMER0 (con quarzo a 4MHz)
    INTCONbits.TMR0IE=1; //Abilitazione degli interrupt generati dal Timer0
    INTCONbits.GIE=1; //Abilitazione interrupt globale (senza il GIE tutti gli interrupt vengono disattivati)
}